package com.sunwin.swismp.config.log;

import ch.qos.logback.classic.pattern.ClassicConverter;
import ch.qos.logback.classic.spi.ILoggingEvent;
import com.sunwin.swismp.constant.InterfaceEnum;


public class LogInterfaceConfig extends ClassicConverter {
    @Override
    public String convert(ILoggingEvent event) {
        StackTraceElement[] callerData = event.getCallerData();
        String className=callerData[1].getClassName();//获取类全名
        if(className.equals("com.sunwin.swismp.exception.CustomExceptionResolver")){
            className = event.getLoggerName();
        }
        InterfaceEnum interfaceEnum= InterfaceEnum.testInterfaceEnum(className);
        if (interfaceEnum!=null){
            return interfaceEnum.getInterfaceName();//返回该接口所属模块名称
        }
        return null;
    }
}
