package com.sunwin.swismp.config.log;

import ch.qos.logback.classic.pattern.ClassicConverter;
import ch.qos.logback.classic.spi.ILoggingEvent;
import com.sunwin.swismp.config.threadlocal.UserOrgContextHolder;
import com.sunwin.swismp.dto.sysfunction.SysUserOrg;

/**
 * @author yangdong
 * @date 2020/1/21
 * @description
 */
public class LogUserOrgIdConfig extends ClassicConverter {
    @Override
    public String convert(ILoggingEvent event) {
        String uidOid=null;
        try {
            SysUserOrg userOrg= UserOrgContextHolder.getUserOrg();
            //获取用户和部门的id 如果获取不到 就用-1 来表示
            if (userOrg!=null){
                if (userOrg.getUserId()!=null && userOrg.getOrgId()!=null){
                    uidOid=userOrg.getUserId()+"|"+userOrg.getOrgId();
                }else{
                    uidOid="-1|-1";
                }
            }else{
                uidOid="-1|-1";
            }
        } catch (Exception e) {
            System.out.println("获取日志用户部门id异常");
        }
        return uidOid;
    }
}
