package com.sunwin.swismp.config.threadlocal;


import com.sunwin.swismp.dto.sysfunction.SysUserOrg;

/**
 * 保存一个map里面存储的是用户部门信息
 */
public class UserOrgContextHolder {
    private static final ThreadLocal<SysUserOrg> contextHolder = new ThreadLocal<>();

    public static final SysUserOrg map = new SysUserOrg(); //默认用户部门信息

    static {
        contextHolder.set(map);
    }
    public static void setUserOrg(SysUserOrg map) {
        contextHolder.set(map);
    }

    public static SysUserOrg getUserOrg() {
        return contextHolder.get();
    }

    public static void clearUserOrg() {
        contextHolder.remove();
    }
}
