package com.sunwin.swismp.constant;
//时间聚合类型
public enum AggregateDateEnum {
    //月聚合类型
    AGG_MONTH(
                "^[0-9]{4}-[0-9]{1,2}$",//日期聚合后的形式 2019-10
                61,// 匹配条件，日期数量61~365*2+1
                365*2+1,
                (String str)->{ //日期表达式转换后的聚合值 如2019-11-03  转换后 2019-11
                    return str.substring(0,7);
                },
                "^\\d{4}-\\d{1,2}-\\d{1,2}$"//要匹配的原始日期表达式 2019-10-21
    ),
    //年聚合类型
    AGG_YEAR(
                "^[0-9]{4}$",//日期聚合后的形式 2019
                365*2+1,// 匹配条件，日期数量大于365*2+1
                Integer.MAX_VALUE,
                (String str)->{//日期表达式转换后的聚合值 如2019-11-03  转换后 2019
                    return str.substring(0,4);
                },
                "^\\d{4}-\\d{1,2}-\\d{1,2}$"//要匹配的原始日期表达式 2019-10-21
    );
    AggregateDateEnum(String strRegx, Integer floor, Integer ceil, AggregateExp aggregateExp, String expectRegx){
        this.strRegx = strRegx;
        this.floor = floor;
        this.ceil = ceil;
        this.exp = aggregateExp;
        this.expectRegx=expectRegx;
    }
    private String expectRegx; //要匹配的日期表达式
    private String strRegx;//聚合后转换成的形式
    private Integer floor;//下界
    private Integer ceil;//上界但不包括
    private AggregateExp exp;//将原始日期表达式转换为聚合值的接口
    interface AggregateExp{
       String parseType(String str);//原始日期表达式转换后的聚合值
    }
    public String getStrRegx() {
        return strRegx;
    }
    public Integer getFloor() {
        return floor;
    }
    public Integer getCeil() {
        return ceil;
    }

    public String getExp(String str) {
        return exp.parseType(str);
    }

    public String getExpectRegx() {
        return expectRegx;
    }
}
