package com.sunwin.swismp.controller.sysfunction;

import com.sunwin.swismp.constant.HttpResponseParam;
import com.sunwin.swismp.constant.MethodDescription;
import com.sunwin.swismp.dto.HttpResult;
import com.sunwin.swismp.dto.PageResult;
import com.sunwin.swismp.service.sysfunction.SysOperationLogService;
import com.sunwin.swismp.util.LoggerMessageUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * Copyright (c) 12/20/2021 All Rights Reserved By SUNWIN
 * <p>
 * Package: com.sunwin.swismp.controller.sysfunction
 * FileName: SysLogController
 *
 * @author duanmin
 * @description
 * @created 2022/2/25 - 13:44
 * @last Modified
 * @history
 */
@RestController
@RequestMapping(value = "/log")
public class SysLogController {
    @Autowired
    private SysOperationLogService sysOperationLogService;
    private Logger logger = LoggerFactory.getLogger(SysLogController.class);

    /**
     * @Description : 查询日志-分页
     * @Return :
     */
    @GetMapping(value = "/querySysLogPage")
    @MethodDescription(description = "查询日志-分页")
    public HttpResult querySysLogPage(@RequestParam(value = "moduleName", required = false) String moduleName,
                                      @RequestParam(value = "operationName", required = false) String operationName,
                                      @RequestParam(value = "roleId", required = false) String roleId,
                                      @RequestParam(value = "beginOperateTime", required = false) String beginOperateTime,
                                      @RequestParam(value = "endOperateTime", required = false) String endOperateTime,
                                      @RequestParam(value = "pageNum") Integer pageNum,
                                      @RequestParam(value = "pageSize") Integer pageSize) {
        HttpResult httpResult = null;
        PageResult pageResult = sysOperationLogService.querySysLogPage(moduleName, operationName, roleId, beginOperateTime,
                endOperateTime, pageNum, pageSize);
        httpResult = new HttpResult(HttpResponseParam.SUCCESS_CODE, HttpResponseParam.SUCCESS_MSG, pageResult);
        LoggerMessageUtil.successfulMsg(logger, "查询日志-分页");
        return httpResult;
    }
}
