package com.sunwin.swismp.util.mobileMessage;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

/**
* @Description: 获取properties配置文件
* @Author: zc
* @CreateDate: 2019/2/28 11:34
* @Remark:
* @Version: 1.0
*/
public class ReadPropertiesUtil {

    private static final String PROPS_FILE = "mobile.properties";

    private static final Properties PROPS;

    static {
        PROPS = loadProps(PROPS_FILE);
    }

    public static Properties loadProps(String file)  {
        InputStream is = ReadPropertiesUtil.class.getClassLoader().getResourceAsStream(PROPS_FILE);
        Properties properties = new Properties();
        try {
            properties.load(is);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (is != null) {
                    is.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return properties;
    }


    public static String GetValueByKey(String key) {
        return PROPS.getProperty(key);
    }

}
