package com.sunwin.swismp.dao.sysfunction.mapper;

import com.sunwin.swismp.bean.sysfunction.SysMenu;
import com.sunwin.swismp.dto.sysfunction.SysMenuDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface SysMenuMapper {
    /**
     * 查询角色能看到的菜单
     * @param roleId
     * @return
     */
    List<SysMenu> selectByRoleId(@Param("roleId") Integer roleId);
    /**
     * 用户id对应的菜单
     * @param userId
     * @return
     */
    List<SysMenu> selectByUserId(@Param("userId") Integer userId);

    /**
     * 菜单明细
     * @param menuId
     * @return
     */
    SysMenuDTO selectMenuById(@Param("menuId") Integer menuId);
    /**
     * 查询次级菜单列表
     * @param menuId
     * @return
     */
    List<SysMenuDTO> queryMenuSecondary(@Param("menuId")Integer menuId,
                                        @Param(value = "resourceType") Integer resourceType,
                                        @Param(value = "isEnable") Integer isEnable,
                                        @Param(value = "keywords") String keywords,
                                        @Param(value = "offset") Integer offset,
                                        @Param(value = "size") Integer size);
    Long queryMenuSecondaryCount(@Param("menuId")Integer menuId,
                                 @Param(value = "resourceType") Integer resourceType,
                                 @Param(value = "isEnable") Integer isEnable,
                                 @Param(value = "keywords") String keywords);

    Long queryMenuCount(@Param("menuId")Integer menuId,
                        @Param(value = "menuName") String menuName,
                        @Param(value = "resourceType") Integer resourceType,
                        @Param(value = "isEnable") Integer isEnable,
                        @Param(value = "keywords") String keywords);

    Long queryMenuOutSelfCount(@Param("menuId")Integer menuId,
                               @Param(value = "menuName") String menuName);

    /**
     * @Description : 插入新增资源信息
     * @param record
     * @Return :
     * @Author : fengyong
     * @Date : 2022/2/16 9:36
     */
    int menuInsert(SysMenu record);


    /**
     * @Description : 根据主键修改资源内容
     * @param record
     * @Return :
     * @Author : fengyong
     * @Date : 2022/2/16 9:36
     */
    int menuUpdateByPrimaryKey(SysMenu record);

    /**
     * @Description : 根据主键修改资源启用状态
     * @param record
     * @Return :
     * @Author : fengyong
     * @Date : 2022/2/16 9:36
     */
    int menuUpdateIsEnableByPrimaryKey(SysMenu record);

    /**
     * @Description : 删除资源
     * @Return :
     */
    Integer deleteMenu(Integer menuId);

    List<SysMenuDTO> querySysMenuTree();


}