package com.sunwin.swismp.service.sysfunction.impl;

import com.sunwin.swismp.bean.sysfunction.SysOperationLog;
import com.sunwin.swismp.config.annotation.DS;
import com.sunwin.swismp.dao.sysfunction.mapper.SysOperationLogMapper;
import com.sunwin.swismp.config.datasource.DataSourceType;
import com.sunwin.swismp.dto.PageResult;
import com.sunwin.swismp.dto.sysfunction.SysOperationLogDTO;
import com.sunwin.swismp.service.sysfunction.SysOperationLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SysOperationLogServiceImpl implements SysOperationLogService {

    @Autowired
    private SysOperationLogMapper sysOperationLogMapper;

    /**
     * 插入操作日志
     * @param log
     * @return
     */
    @Override
    @DS(value = DataSourceType.postgreDS)
    public int insertOperationLog(SysOperationLog log) {
        return sysOperationLogMapper.insert(log);
    }

    /**
     * 日志查询-分页
     * @param moduleName
     * @param operationName
     * @param roleId
     * @param beginOperateTime
     * @param endOperateTime
     * @param pageNum
     * @param pageSize
     * @return
     */
    @Override
    @DS(value = DataSourceType.postgreDS)
    public PageResult querySysLogPage(String moduleName, String operationName, String roleId, String beginOperateTime,
                                      String endOperateTime, Integer pageNum, Integer pageSize) {
        List<SysOperationLogDTO> sysOperationLogDTOList = sysOperationLogMapper.querySysLogPage(moduleName, operationName,
                roleId, beginOperateTime, endOperateTime, (pageNum - 1) * pageSize, pageSize);
        Long count = sysOperationLogMapper.querySysLogPageCount(moduleName, operationName, roleId, beginOperateTime,
                endOperateTime);
        return new PageResult(count, sysOperationLogDTOList);
    }
}
