package com.sunwin.swismp.service.sysfunction.impl;

import com.sunwin.swismp.config.annotation.DS;
import com.sunwin.swismp.config.datasource.DataSourceType;
import com.sunwin.swismp.dao.sysfunction.mapper.SysRoleMenuPermissionsMapper;
import com.sunwin.swismp.dto.sysfunction.SysRoleMenuPermissions;
import com.sunwin.swismp.service.sysfunction.SysRoleMenuPermissionsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 系统角色菜单权限接口实现类
 * @Author: fengyong
 * @CreateDate: 2019/7/12
 * @Remark:
 * @Version: 1.0
 */
@Service
public class SysRoleMenuPermissionsServiceImpl implements SysRoleMenuPermissionsService {
    @Autowired
    SysRoleMenuPermissionsMapper sysRoleMenuPermissionsMapper;
    /**
     * @Description : 查询权限信息
     * @param roleId
     * @param type
     * @Return :
     * @Author : yangdong
     * @Date : 2020/2/28 15:12
    */
    @Override
    @DS(DataSourceType.postgreDS)
    public Map selectByRoleId(Integer roleId,String type) { //type : all查询全部 ; self 查询已有的
        List<SysRoleMenuPermissions> sysRoleMenuPermissionsList=null;
        if("all".equals(type)){
            sysRoleMenuPermissionsList = sysRoleMenuPermissionsMapper.selectByRoleId(roleId);
        }else if("self".equals(type)){
            sysRoleMenuPermissionsList = sysRoleMenuPermissionsMapper.selectByRoleIdSelf(roleId);
        }else {
            sysRoleMenuPermissionsList = new ArrayList<>();
        }
        List<Integer> chooseMenue = new ArrayList();
        List<Map> roleMenuList = new ArrayList<>();//返回结果集

        //List<Object> twoMenuList = new ArrayList<>();
        for (SysRoleMenuPermissions sysRoleMenuPermissions:sysRoleMenuPermissionsList){
            //数据投入容器标志
            boolean check =false;
            /**
             * 遍历容器
             */
            for (Map onelistMap:roleMenuList ){
               //找到所在一级菜单
                Integer oneId = (Integer) onelistMap.get("id");
                if (oneId==sysRoleMenuPermissions.getOneMenuId()){
                    if (sysRoleMenuPermissions.getTwoMenuId()!=null){
                        //找到二级菜单
                        List<Map> twoMenuList = (List<Map>) onelistMap.get("children");
                        if (twoMenuList==null) twoMenuList = new ArrayList<>();
                        for (Map twolistMap:twoMenuList){
                            Integer twoId = (Integer) twolistMap.get("id");
                            if (twoId==sysRoleMenuPermissions.getTwoMenuId()){
                                if (sysRoleMenuPermissions.getThreeMenuId()!=null){
                                    //找到三级菜单
                                    List<Map> threeMenuList = (List<Map>) twolistMap.get("children");
                                    //投入数据
                                    if (threeMenuList==null) threeMenuList = new ArrayList<>();
                                    Map map3 = new HashMap();
                                    map3.put("id",sysRoleMenuPermissions.getThreeMenuId());
                                    map3.put("title",sysRoleMenuPermissions.getThreeMenuName());
                                    map3.put("checked", sysRoleMenuPermissions.getThreeIsShown() != null && sysRoleMenuPermissions.getThreeIsShown() == 1);
                                    map3.put("expand", sysRoleMenuPermissions.getThreeIsShown() != null && sysRoleMenuPermissions.getThreeIsShown() == 1);
                                    if (sysRoleMenuPermissions.getThreeIsShown() != null && sysRoleMenuPermissions.getThreeIsShown() == 1)
                                        chooseMenue.add(sysRoleMenuPermissions.getThreeMenuId());
                                    threeMenuList.add(map3);
                                    twolistMap.put("checked",(boolean)twolistMap.get("checked")?map3.get("checked"):twolistMap.get("checked"));//父节点半勾选处理
                                    check = true;
                                }
                                onelistMap.put("checked",(boolean)onelistMap.get("checked")?twolistMap.get("checked"):onelistMap.get("checked"));//父节点半勾选处理
                            }
                        }
                        if (!check){
                            //未找到二级菜单列表投入数据
                            Map map2 = new HashMap();
                            map2.put("id",sysRoleMenuPermissions.getTwoMenuId());
                            map2.put("title",sysRoleMenuPermissions.getTwoMenuName());
                            map2.put("checked", sysRoleMenuPermissions.getTwoIsShown() != null && sysRoleMenuPermissions.getTwoIsShown() == 1);
                            map2.put("expand", sysRoleMenuPermissions.getTwoIsShown() != null && sysRoleMenuPermissions.getTwoIsShown() == 1);
                            if (sysRoleMenuPermissions.getTwoIsShown() != null && sysRoleMenuPermissions.getTwoIsShown() == 1)
                                chooseMenue.add(sysRoleMenuPermissions.getTwoMenuId());
                            List<Map> threelist = new ArrayList<>();
                            if (sysRoleMenuPermissions.getThreeMenuId()!=null){
                                Map map3 = new HashMap();
                                map3.put("id",sysRoleMenuPermissions.getThreeMenuId());
                                map3.put("title",sysRoleMenuPermissions.getThreeMenuName());
                                map3.put("checked", sysRoleMenuPermissions.getThreeIsShown() != null && sysRoleMenuPermissions.getThreeIsShown() == 1);
                                map3.put("expand", sysRoleMenuPermissions.getThreeIsShown() != null && sysRoleMenuPermissions.getThreeIsShown() == 1);
                                if (sysRoleMenuPermissions.getThreeIsShown() != null && sysRoleMenuPermissions.getThreeIsShown() == 1)
                                    chooseMenue.add(sysRoleMenuPermissions.getThreeMenuId());
                                map2.put("checked",(boolean)map2.get("checked")?map3.get("checked"):map2.get("checked"));//父节点半勾选处理
                                threelist.add(map3);
                            }
                            map2.put("children",threelist);
                            twoMenuList.add(map2);
                            onelistMap.put("checked",(boolean)onelistMap.get("checked")?map2.get("checked"):onelistMap.get("checked"));//父节点半勾选处理
                            onelistMap.put("children",twoMenuList);
                            check = true;
                        }

                    }
                }
            }
            if (!check){
              //初次投入数据
                Map map1 = new HashMap();
                map1.put("id",sysRoleMenuPermissions.getOneMenuId());
                map1.put("title",sysRoleMenuPermissions.getOneMenuName());
                map1.put("checked", sysRoleMenuPermissions.getOneIsShown() != null && sysRoleMenuPermissions.getOneIsShown() == 1);
                map1.put("expand", sysRoleMenuPermissions.getOneIsShown() != null && sysRoleMenuPermissions.getOneIsShown() == 1);
                if (sysRoleMenuPermissions.getOneIsShown() != null && sysRoleMenuPermissions.getOneIsShown()==1)
                    chooseMenue.add(sysRoleMenuPermissions.getOneMenuId());
                List<Map> twolist = new ArrayList<>();
                boolean checkTemp = false;
                Map map2 = new HashMap();
                if (sysRoleMenuPermissions.getTwoMenuId()!=null){
                    map2.put("id",sysRoleMenuPermissions.getTwoMenuId());
                    map2.put("title",sysRoleMenuPermissions.getTwoMenuName());
                    map2.put("checked", sysRoleMenuPermissions.getTwoIsShown() != null && sysRoleMenuPermissions.getTwoIsShown() == 1);
                    map2.put("expand", sysRoleMenuPermissions.getTwoIsShown() != null && sysRoleMenuPermissions.getTwoIsShown() == 1);
                    if (sysRoleMenuPermissions.getTwoIsShown() != null && sysRoleMenuPermissions.getTwoIsShown() == 1)
                        chooseMenue.add(sysRoleMenuPermissions.getTwoMenuId());
                    List<Map> threelist = new ArrayList<>();
                    if (sysRoleMenuPermissions.getThreeMenuId()!=null){
                        Map map3 = new HashMap();
                        map3.put("id",sysRoleMenuPermissions.getThreeMenuId());
                        map3.put("title",sysRoleMenuPermissions.getThreeMenuName());
                        map3.put("checked", sysRoleMenuPermissions.getThreeIsShown() != null && sysRoleMenuPermissions.getThreeIsShown() == 1);
                        map3.put("expand", sysRoleMenuPermissions.getThreeIsShown() != null && sysRoleMenuPermissions.getThreeIsShown() == 1);
                        if (sysRoleMenuPermissions.getThreeIsShown() != null && sysRoleMenuPermissions.getThreeIsShown() == 1)
                            chooseMenue.add(sysRoleMenuPermissions.getThreeMenuId());
                        threelist.add(map3);
                        map2.put("checked",(boolean)map2.get("checked")?map3.get("checked"):map2.get("checked"));//父节点半勾选处理
                    }
                    map1.put("checked",(boolean)map1.get("checked")?map2.get("checked"):map1.get("checked"));//父节点半勾选处理
                    map2.put("children",threelist);
                    twolist.add(map2);
                }
                map1.put("children",twolist);
                roleMenuList.add(map1);
                check = true;
            }

        }
        Map map = new HashMap();
        map.put("chooseMenu",chooseMenue);
        map.put("menuList",roleMenuList);
        return map;
    }
}
