package com.sunwin.swismp.dto.sysfunction;


import com.sunwin.swismp.bean.sysfunction.SysMenu;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class SysMenuResult implements Serializable {

    private Integer menuId;

    private String menuName;

    private Integer parentMenuId;

    private String linkUrl;

    private String imageUrl;

    private String bz;

    private List<SysMenuResult> childMenus;

    public SysMenuResult() {
    }

    public SysMenuResult(SysMenu sysMenu) {
        this.menuId = sysMenu.getMenuId();
        this.menuName = sysMenu.getMenuName();
        this.parentMenuId = sysMenu.getParentMenuId();
        this.linkUrl = sysMenu.getLinkUrl();
        this.imageUrl = sysMenu.getImageUrl();
        this.bz = sysMenu.getBz();
    }

    public Integer getMenuId() {
        return menuId;
    }

    public void setMenuId(Integer menuId) {
        this.menuId = menuId;
    }

    public String getMenuName() {
        return menuName;
    }

    public void setMenuName(String menuName) {
        this.menuName = menuName;
    }

    public Integer getParentMenuId() {
        return parentMenuId;
    }

    public void setParentMenuId(Integer parentMenuId) {
        this.parentMenuId = parentMenuId;
    }

    public String getLinkUrl() {
        return linkUrl;
    }

    public void setLinkUrl(String linkUrl) {
        this.linkUrl = linkUrl;
    }

    public String getImageUrl() {
        return imageUrl;
    }

    public void setImageUrl(String imageUrl) {
        this.imageUrl = imageUrl;
    }

    public String getBz() {
        return bz;
    }

    public void setBz(String bz) {
        this.bz = bz;
    }

    public List<SysMenuResult> getChildMenus() {
        return childMenus;
    }

    public void setChildMenus(List<SysMenuResult> childMenus) {
        this.childMenus = childMenus;
    }

    public SysMenuResult addChildMenu(SysMenuResult menu) {
        if (this.childMenus == null) {
            this.childMenus = new ArrayList<>();
        }
        if (menu != null) {
            this.childMenus.add(menu);
        }
        return this;
    }
}
