package com.sunwin.swismp.service.sysfunction;


import com.sunwin.swismp.bean.TreeNode;
import com.sunwin.swismp.bean.sysfunction.SysMenu;
import com.sunwin.swismp.dto.HttpResult;
import com.sunwin.swismp.dto.PageResult;
import com.sunwin.swismp.dto.sysfunction.SysMenuDTO;
import com.sunwin.swismp.dto.sysfunction.SysMenuResult;

import java.util.List;

public interface SysMenuService {

    /**
     * 查询角色能看到的菜单
     * @param roleId
     * @return
     */
    List<SysMenuResult> selectByRoleId(Integer roleId);
    /**
     * 用户id对应的菜单
     * @param userId
     * @return
     */
    List<SysMenuResult> selectByUserId(Integer userId);

    /**
     * 菜单明细
     * @param menuId
     * @return
     */
    SysMenuDTO selectMenuById(Integer menuId);

    /**
     * 查询次级菜单列表
     * @param menuId
     * @return
     */
    PageResult queryMenuSecondary(Integer menuId,
                                  Integer resourceType, Integer isEnable, String keywords,
                                  Integer pageNum, Integer pageSize);

    /**
     * 保存系统资源信息（新增、修改）
     * @param sysMenu
     * @return
     */
    HttpResult menuSave(SysMenu sysMenu);

    /**
     * 修改启用状态
     * @param sysMenu
     * @return
     */
    Integer updateEnabled(SysMenu sysMenu);
    /**
     * @Description : 删除资源
     * @Return :
     */
    Integer deleteMenu(Integer menuId);

    /**
     * @Description : 系统资源菜单树
     * @Return :
     */
    List<TreeNode> sysMenuTree();
}
