package com.sunwin.swismp.util;


import org.springframework.web.multipart.MultipartFile;

import java.io.*;

public class FileUtils {

    public static File MultipartFileToFile(MultipartFile multipartFile){
        int n;
        File f = null;
        // 输出文件的新name 就是指上传后的文件名称
        System.out.println("getName:"+multipartFile.getName());
        // 输出源文件名称 就是指上传前的文件名称
        System.out.println("Oriname:"+multipartFile.getOriginalFilename());
        // 创建文件
        f = new File(multipartFile.getOriginalFilename());
        try (InputStream in  = multipartFile.getInputStream(); OutputStream os = new FileOutputStream(f)){
            // 得到文件流。以文件流的方式输出到新文件
            // 可以使用byte[] ss = multipartFile.getBytes();代替while
            byte[] buffer = new byte[4096];
            while ((n = in.read(buffer,0,4096)) != -1){
                os.write(buffer,0,n);
            }
            // 读取文件第一行
            BufferedReader bufferedReader = new BufferedReader(new FileReader(f));
            System.out.println(bufferedReader.readLine());
            // 输出路径
            bufferedReader.close();

            // 输出file的URL
            System.out.println(f.toURI().toURL().toString());
        }catch (IOException e){
            e.printStackTrace();
        }
        // 输出文件的绝对路径
        System.out.println(f.getAbsolutePath());
        return f;
    }
    public static void deleteFlie(File file){
        // 操作完上的文件 需要删除在根目录下生成的文件
        //File file = new File(f.toURI());
        if (file.delete()){
            System.out.println("删除成功");
        }else {
            System.out.println("删除失败");
        }
    }
}
