package com.sunwin.swismp.util;

import com.sunwin.swismp.bean.sysfunction.SysUser;
import org.springframework.util.DigestUtils;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class Md5Util {
    public enum TimeMd5Type {
        DATE("yyyy-MM-dd", Calendar.DATE, 0), MINIUTE("yyyy-MM-dd HH:mm", Calendar.MINUTE, 30);

        TimeMd5Type(String format, Integer type, Integer adjust) {
            this.format = format;
            this.type = type;
            this.adjust = adjust;
        }

        public Integer type;//时间类型细粒度
        public String format;//时间格式
        private Integer adjust;
    }

    //  获取时间偏差调整区间
    public static List<String> md5AdjustTime(TimeMd5Type time) {
        List<String> timeList = new ArrayList<>();
        Date date = new Date();
        DateFormat df = new SimpleDateFormat(time.format);
        timeList.add(df.format(date));
        Calendar calendarFront = Calendar.getInstance();
        calendarFront.setTime(date);
        Calendar calendarBehind = Calendar.getInstance();
        calendarBehind.setTime(date);
        for (int i = 0; i < time.adjust; i++) {
            calendarFront.add(time.type, 1);
            calendarBehind.add(time.type, -1);
            timeList.add(df.format(calendarFront.getTime()));
            timeList.add(df.format(calendarBehind.getTime()));
        }
        return timeList;
    }

    //md5加密
    public static String md5(String plainText) {
        return DigestUtils.md5DigestAsHex(plainText.getBytes());
    }

    //比较用户请求的md5值和系统生成的md5修正值
    public static Boolean processUser(String md5Text, SysUser sysUser, TimeMd5Type time) {
        List<String> timeList = md5AdjustTime(time);
        for (String timeMem : timeList) {
            String pwdMd5 = Md5Util.md5("userName:" + sysUser.getUserName() + "-userPwd:"
                    + sysUser.getUserPwd() + "-time:" + timeMem);
            if (md5Text.equals(pwdMd5))
                return true;

        }
        return false;
    }


    //比较用户请求的md5值和系统生成的md5修正值
    public static Boolean processUserId(String md5Text, SysUser sysUser, TimeMd5Type time) {
        List<String> timeList = md5AdjustTime(time);
        for (String timeMem : timeList) {
            String pwdMd5 = Md5Util.md5("userId:" + sysUser.getUserId() + "-userName:" + sysUser.getUserName()
                    + "-userPwd:" + sysUser.getUserPwd() + "-time:" + timeMem);
            if (md5Text.equals(pwdMd5))
                return true;

        }
        return false;
    }
}
