package com.sunwin.swismp.constant;


import java.util.Calendar;


/**
 * @Description : 时间间隔解析类
 * @Author : yangdong
 * @Date : 2020/3/2 10:46
*/
public enum TimeIntervalEnum {
    HOUR(60*60*1000L,"HH:mm",Calendar.HOUR_OF_DAY,Calendar.MINUTE),
    DAY(24*60*60*1000L,"yyyy-MM-dd",Calendar.DAY_OF_YEAR,Calendar.HOUR_OF_DAY),
    MONTH(24*60*60*1000*30L,"yyyy-MM",Calendar.MONTH,Calendar.DAY_OF_MONTH),
    YEAR(24*60*60*1000*365L,"yyyy",Calendar.YEAR,Calendar.DAY_OF_YEAR);
    //时间间隔
    private Long interval;
    //日期表达形式
    private String dateFormat;
    //统一处理的日期格式 包括 年月日 时分秒可共享
    //间隔点与间隔点之间的间隔
    private Integer seperatorInterval;
    //间隔点开始时间与结束时间的间隔
    private Integer innerInterval;

    TimeIntervalEnum(Long interval, String dateFormat, Integer seperatorInterval, Integer innerInterval) {
        this.interval = interval;
        this.dateFormat = dateFormat;
        this.seperatorInterval = seperatorInterval;
        this.innerInterval = innerInterval;
    }

    public Long getInterval() {
        return interval;
    }

    public String getDateFormat() {
        return dateFormat;
    }

    public Integer getSeperatorInterval() {
        return seperatorInterval;
    }

    public Integer getInnerInterval() {
        return innerInterval;
    }
}
