package com.sunwin.swismp.dto;


import com.sunwin.swismp.constant.HttpResponseParam;

import java.io.Serializable;
/**
 * http请求返回数据格式
 */
public class HttpResult<T> implements Serializable {

    private int httpCode;

    private String msg;

    private String description;

    private T data;

    public HttpResult(int httpCode, String msg, T data) {
        this.httpCode = httpCode;
        this.msg = msg;
        this.data = data;
    }

    public HttpResult(int httpCode, String msg) {
        this.httpCode = httpCode;
        this.msg = msg;
    }


    /**
     * 构造一个成功的结果返回
     */
    public HttpResult() {
        this.setHttpCode(HttpResponseParam.SUCCESS_CODE);
        this.setMsg(HttpResponseParam.SUCCESS_MSG);
    }

    /**
     * 构造一个带msg的结果返回
     */
    public HttpResult(String msg) {
        this.setMsg(msg);
    }

    public int getHttpCode() {
        return httpCode;
    }

    public void setHttpCode(int httpCode) {
        this.httpCode = httpCode;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public T getData() {
        return data;
    }

    public void setData(T data) {
        this.data = data;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
}
